import { Ng2BootstrapModule } from 'ng2-bootstrap/ng2-bootstrap';
import { NgModule, ApplicationRef } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { HttpModule } from '@angular/http';
import { RouterModule, PreloadAllModules } from '@angular/router';
import { removeNgStyles, createNewHosts, createInputTransfer } from '@angularclass/hmr';

/*
 * Platform and Environment providers/directives/pipes
 */
import { ENV_PROVIDERS } from './environment';
import { ROUTES } from './app.routes';
// App is our top level component
import { AppComponent } from './app.component';
import { APP_RESOLVER_PROVIDERS } from './app.resolver';
import { NoContentComponent } from './no-content';
import { HomeComponent } from './home/home.component';

// Application wide providers
const APP_PROVIDERS = [
  ...APP_RESOLVER_PROVIDERS
];

/**
 * `AppModule` is the main entry point into Angular2's bootstraping process
 */
@NgModule({
  bootstrap: [AppComponent],
  declarations: [
    AppComponent,       //Application`s Root Component including the router outlet
    HomeComponent,      //Application Starting point
    NoContentComponent, //Modul that will be loaded if an invalid 
  ],
  imports: [ // import Angular's modules
    BrowserModule,
    FormsModule,
    HttpModule,
    RouterModule.forRoot(ROUTES, { useHash: true, preloadingStrategy: PreloadAllModules }),
    Ng2BootstrapModule
  ],
  providers: [
    APP_PROVIDERS
  ]
})
export class AppModule {

  constructor() {

  }

  hmrOnInit() {

  }

  hmrOnDestroy() {
    removeNgStyles();
  }

  hmrAfterDestroy() {

  }

}

